from django.shortcuts import render,redirect
from django.contrib.auth.decorators import login_required  


from django.contrib import messages
from django.contrib.auth import authenticate, login as auth_login, logout

from django.http import JsonResponse
from django.views.decorators.csrf import csrf_exempt
from .models import Account


def login(request):
    if request.method == 'POST':
        email = request.POST.get('email')
        password = request.POST.get('password')

        if email and password:  # Check if email and password are provided
            user = authenticate(username=email, password=password)
            if user is not None:  # Check if user exists
                auth_login(request, user)
                request.session['user_id'] = user.id
                # messages.success(request, 'Login successful.')  # Success message
                return redirect('/')
            else:
                messages.error(request, 'Invalid email or password.')  # Error message
        else:
            messages.error(request, 'Please provide both email and password.')  # Error message

        # Redirect back to login page with messages
        return render(request, 'index.html')

    return render(request, 'index.html')

@login_required
def logout_view(request):
    logout(request)
    messages.success(request, 'Logout successful.')
    return redirect('account:login')


@csrf_exempt
def check_existing(request):
    if request.method == 'POST':
        phone_number = request.POST.get('phone_number')
        email = request.POST.get('email')

        if phone_number:
            if Account.objects.filter(phone_number=phone_number).exists():
                return JsonResponse({'message': 'Phone number already exists'})
            else:
                return JsonResponse({'message': 'Phone number is available'})

        elif email:
            if Account.objects.filter(email=email).exists():
                return JsonResponse({'message': 'Email already exists'})
            else:
                return JsonResponse({'message': 'Email is available'})

    return JsonResponse({'error': 'Invalid request method'}, status=400)


from django.http import JsonResponse

import json
from django.http import JsonResponse

import json
from django.http import JsonResponse

def validate_admin_key(request):
    if request.method == 'POST':
        # Get the admin key from the request body
        data = json.loads(request.body)
        admin_key = data.get('adminKey')

        account = Account.objects.filter(key=admin_key).first()

        # Check if the admin key is valid (replace this with your validation logic)
        if account:
            response_data = {'valid': True, 'adminId': account.id}
            status = 200
        else:
            response_data = {'valid': False, 'error': 'Invalid administrator key'}
            status = 400

        return JsonResponse(response_data, status=status)

    # Handle other HTTP methods if needed
    return JsonResponse({'error': 'Invalid request method'}, status=405)


def account(request):
    return render(request, 'account.html')








 